flat out vec3 colSunlight;
flat out vec3 colSkylight;
flat out vec3 colSky;
flat out vec3 colHorizon;
flat out vec3 colSunglow;
flat out vec2 fogDensity;

uniform vec3 skyColor;
uniform vec3 fogColor;
uniform float rainStrength;

#include "/lib/util/colorConversion.glsl"

void nature() {

    #if s_colorprofile==0
        //chocapic v3 colors
        vec3 sunlightSunrise;
            sunlightSunrise.r = 1.0;
            sunlightSunrise.g = 0.53;
            sunlightSunrise.b = 0.09;
            sunlightSunrise *= 1.0;

        vec3 sunlightNoon;
            sunlightNoon.r = 1.0;
            sunlightNoon.g = 0.79;
            sunlightNoon.b = 0.58;
            sunlightNoon *= 1.2;

        vec3 sunlightSunset;
            sunlightSunset.r = 1.0;
            sunlightSunset.g = 0.53;
            sunlightSunset.b = 0.09;
            sunlightSunset *= 1.0;

        vec3 sunlightNight;
            sunlightNight.r = 0.26;
            sunlightNight.g = 0.39;
            sunlightNight.b = 1.0;
            sunlightNight *= 0.3;

        colSunlight = sunlightSunrise*timeSunrise + sunlightNoon*timeNoon + sunlightSunset*timeSunset + sunlightNight*timeNight;

        vec3 skylightSunrise;
            skylightSunrise.r = 0.39;
            skylightSunrise.g = 0.39;
            skylightSunrise.b = 1.0;
            skylightSunrise *= 0.5;

        vec3 skylightNoon;
            skylightNoon.r = 0.46;
            skylightNoon.g = 0.46;
            skylightNoon.b = 1.0;
            skylightNoon *= 0.9;

        vec3 skylightSunset;
            skylightSunset.r = 0.39;
            skylightSunset.g = 0.39;
            skylightSunset.b = 1.0;
            skylightSunset *= 0.5;

        vec3 skylightNight;
            skylightNight.r = 0.13;
            skylightNight.g = 0.22;
            skylightNight.b = 1.0;
            skylightNight *= 0.1;

        colSkylight = skylightSunrise*timeSunrise + skylightNoon*timeNoon + skylightSunset*timeSunset + skylightNight*timeNight;

        vec3 sunlightMod    = mix(normalize(colSkylight), vec3(1.0), timeNight*0.6);

        colSky = toLinear(skyColor)*3.0*sunlightMod*vec3(1.0, 2.3, 1.0);
        colSky = colorSat(colSky, 0.66);
        colSky = mix(colSky, vec3(vec3avg(colSky)), rainStrength*0.92);

        vec3 horizonSunrise;
            horizonSunrise.r = 0.24;
            horizonSunrise.g = 0.68;
            horizonSunrise.b = 1.0;
            horizonSunrise *= 0.4;

        vec3 horizonNoon = pow(fogColor, vec3(2.2));
            horizonNoon *= 1.0;

        vec3 horizonSunset;
            horizonSunset.r = 0.18;
            horizonSunset.g = 0.66;
            horizonSunset.b = 1.0;
            horizonSunset *= 0.65;

        vec3 horizonNight;
            horizonNight.r = 0.08;
            horizonNight.g = 0.5;
            horizonNight.b = 1.0;
            horizonNight *= 0.06;

        colHorizon = horizonSunrise*timeSunrise + horizonNoon*timeNoon + horizonSunset*timeSunset + horizonNight*timeNight;
        colHorizon *= (1-timeMoon*0.89);
        colHorizon = mix(colHorizon, vec3(vec3avg(colHorizon)), rainStrength*0.8);

        vec3 sunglowSunrise;
            sunglowSunrise.r = 1.0;
            sunglowSunrise.g = 0.14;
            sunglowSunrise.b = 0.00;
            sunglowSunrise *= 0.9;

        vec3 sunglowNoon;
            sunglowNoon.r = 0.56;
            sunglowNoon.g = 0.74;
            sunglowNoon.b = 1.0;
            sunglowNoon *= 0.9;

        vec3 sunglowSunset;
            sunglowSunset.r = 1.0;
            sunglowSunset.g = 0.08;
            sunglowSunset.b = 0.0;
            sunglowSunset *= 0.8;

        vec3 sunglowNight;
            sunglowNight.r = 0.08;
            sunglowNight.g = 0.5;
            sunglowNight.b = 1.0;
            sunglowNight *= 0.004;

        colSunglow = sunglowSunrise*timeSunrise + sunglowNoon*timeNoon + sunglowSunset*timeSunset + sunlightNight*timeNight;
        colSunglow = mix(colSunglow, vec3(vec3avg(colSunglow)), rainStrength*0.5);

    #elif s_colorprofile==1
        //plunderpixel colors
        vec3 sunlightSunrise;
            sunlightSunrise.r = 1.0;
            sunlightSunrise.g = 0.53;
            sunlightSunrise.b = 0.07;
            sunlightSunrise *= 1.0;

        vec3 sunlightNoon;
            sunlightNoon.r = 1.0;
            sunlightNoon.g = 0.79;
            sunlightNoon.b = 0.58;
            sunlightNoon *= 1.2;

        vec3 sunlightSunset;
            sunlightSunset.r = 1.0;
            sunlightSunset.g = 0.53;
            sunlightSunset.b = 0.07;
            sunlightSunset *= 1.0;

        vec3 sunlightNight;
            sunlightNight.r = 0.26;
            sunlightNight.g = 0.39;
            sunlightNight.b = 1.0;
            sunlightNight *= 0.3;

        colSunlight = sunlightSunrise*timeSunrise + sunlightNoon*timeNoon + sunlightSunset*timeSunset + sunlightNight*timeNight;

        vec3 skylightSunrise;
            skylightSunrise.r = 0.39;
            skylightSunrise.g = 0.39;
            skylightSunrise.b = 1.0;
            skylightSunrise *= 0.5;

        vec3 skylightNoon;
            skylightNoon.r = 0.46;
            skylightNoon.g = 0.46;
            skylightNoon.b = 1.0;
            skylightNoon *= 0.9;

        vec3 skylightSunset;
            skylightSunset.r = 0.39;
            skylightSunset.g = 0.39;
            skylightSunset.b = 1.0;
            skylightSunset *= 0.5;

        vec3 skylightNight;
            skylightNight.r = 0.13;
            skylightNight.g = 0.22;
            skylightNight.b = 1.0;
            skylightNight *= 0.1;

        colSkylight = skylightSunrise*timeSunrise + skylightNoon*timeNoon + skylightSunset*timeSunset + skylightNight*timeNight;

        vec3 sunlightMod    = mix(normalize(colSkylight), vec3(1.0), timeNight*0.6);

        colSky = toLinear(skyColor)*2.5*sunlightMod*vec3(1.0, 2.6, 1.0);
        colSky = colorSat(colSky, 0.68);
        colSky = mix(colSky, vec3(vec3avg(colSky)), rainStrength*0.92);

        vec3 horizonSunrise;
            horizonSunrise.r = 0.24;
            horizonSunrise.g = 0.68;
            horizonSunrise.b = 1.0;
            horizonSunrise *= 0.4;

        vec3 horizonNoon = pow(fogColor, vec3(2.2));
            horizonNoon *= 1.2;

        vec3 horizonSunset;
            horizonSunset.r = 0.18;
            horizonSunset.g = 0.66;
            horizonSunset.b = 1.0;
            horizonSunset *= 0.65;

        vec3 horizonNight;
            horizonNight.r = 0.08;
            horizonNight.g = 0.5;
            horizonNight.b = 1.0;
            horizonNight *= 0.06;

        colHorizon = horizonSunrise*timeSunrise + horizonNoon*timeNoon + horizonSunset*timeSunset + horizonNight*timeNight;
        colHorizon *= (1-timeMoon*0.89);
        colHorizon = mix(colHorizon, vec3(vec3avg(colHorizon)), rainStrength*0.8);

        vec3 sunglowSunrise;
            sunglowSunrise.r = 1.0;
            sunglowSunrise.g = 0.14;
            sunglowSunrise.b = 0.00;
            sunglowSunrise *= 0.9;

        vec3 sunglowNoon;
            sunglowNoon.r = 0.56;
            sunglowNoon.g = 0.74;
            sunglowNoon.b = 1.0;
            sunglowNoon *= 0.9;

        vec3 sunglowSunset;
            sunglowSunset.r = 1.0;
            sunglowSunset.g = 0.08;
            sunglowSunset.b = 0.0;
            sunglowSunset *= 0.8;

        vec3 sunglowNight;
            sunglowNight.r = 0.08;
            sunglowNight.g = 0.5;
            sunglowNight.b = 1.0;
            sunglowNight *= 0.004;

        colSunglow = sunglowSunrise*timeSunrise + sunglowNoon*timeNoon + sunglowSunset*timeSunset + sunlightNight*timeNight;
        colSunglow = mix(colSunglow, vec3(vec3avg(colSunglow)), rainStrength*0.5);

    #elif s_colorprofile==2
        //rudoplays colors
        vec3 sunlightSunrise;
            sunlightSunrise.r = 1.0;
            sunlightSunrise.g = 0.61;
            sunlightSunrise.b = 0.17;
            sunlightSunrise *= 1.0;

        vec3 sunlightNoon;
            sunlightNoon.r = 1.0;
            sunlightNoon.g = 0.93;
            sunlightNoon.b = 0.9;
            sunlightNoon *= 1.2;

        vec3 sunlightSunset;
            sunlightSunset.r = 1.0;
            sunlightSunset.g = 0.61;
            sunlightSunset.b = 0.17;
            sunlightSunset *= 1.0;

        vec3 sunlightNight;
            sunlightNight.r = 0.26;
            sunlightNight.g = 0.39;
            sunlightNight.b = 1.0;
            sunlightNight *= 0.3;

        colSunlight = sunlightSunrise*timeSunrise + sunlightNoon*timeNoon + sunlightSunset*timeSunset + sunlightNight*timeNight;

        vec3 skylightSunrise;
            skylightSunrise.r = 0.78;
            skylightSunrise.g = 0.78;
            skylightSunrise.b = 1.0;
            skylightSunrise *= 0.5;

        vec3 skylightNoon;
            skylightNoon.r = 0.89;
            skylightNoon.g = 0.89;
            skylightNoon.b = 1.0;
            skylightNoon *= 0.7;

        vec3 skylightSunset;
            skylightSunset.r = 0.78;
            skylightSunset.g = 0.78;
            skylightSunset.b = 1.0;
            skylightSunset *= 0.5;

        vec3 skylightNight;
            skylightNight.r = 0.13;
            skylightNight.g = 0.22;
            skylightNight.b = 1.0;
            skylightNight *= 0.1;

        colSkylight = skylightSunrise*timeSunrise + skylightNoon*timeNoon + skylightSunset*timeSunset + skylightNight*timeNight;

        vec3 sunlightMod    = mix(normalize(colSkylight), vec3(1.0), timeNight*0.6);

        colSky = toLinear(skyColor)*3.0*sunlightMod*vec3(1.0, 1.35, 1.0);
        colSky = colorSat(colSky, 0.9);
        colSky = mix(colSky, vec3(vec3avg(colSky)), rainStrength*0.92);

        vec3 horizonSunrise;
            horizonSunrise.r = 0.24;
            horizonSunrise.g = 0.68;
            horizonSunrise.b = 1.0;
            horizonSunrise *= 0.4;

        vec3 horizonNoon = pow(fogColor, vec3(2.2))*vec3(0.7, 0.9, 1.0);
            horizonNoon *= 0.95;

        vec3 horizonSunset;
            horizonSunset.r = 0.18;
            horizonSunset.g = 0.66;
            horizonSunset.b = 1.0;
            horizonSunset *= 0.65;

        vec3 horizonNight;
            horizonNight.r = 0.08;
            horizonNight.g = 0.5;
            horizonNight.b = 1.0;
            horizonNight *= 0.06;

        colHorizon = horizonSunrise*timeSunrise + horizonNoon*timeNoon + horizonSunset*timeSunset + horizonNight*timeNight;
        colHorizon *= (1-timeMoon*0.89);
        colHorizon = mix(colHorizon, vec3(vec3avg(colHorizon)), rainStrength*0.8);

        vec3 sunglowSunrise;
            sunglowSunrise.r = 1.0;
            sunglowSunrise.g = 0.14;
            sunglowSunrise.b = 0.00;
            sunglowSunrise *= 0.9;

        vec3 sunglowNoon;
            sunglowNoon.r = 0.56;
            sunglowNoon.g = 0.74;
            sunglowNoon.b = 1.0;
            sunglowNoon *= 0.9;

        vec3 sunglowSunset;
            sunglowSunset.r = 1.0;
            sunglowSunset.g = 0.08;
            sunglowSunset.b = 0.0;
            sunglowSunset *= 0.8;

        vec3 sunglowNight;
            sunglowNight.r = 0.08;
            sunglowNight.g = 0.5;
            sunglowNight.b = 1.0;
            sunglowNight *= 0.004;

        colSunglow = sunglowSunrise*timeSunrise + sunglowNoon*timeNoon + sunglowSunset*timeSunset + sunlightNight*timeNight;
        colSunglow = mix(colSunglow, vec3(vec3avg(colSunglow)), rainStrength*0.5);

    #endif

    fogDensity  = vec2(0.45, 2.0);
}